<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑服务' : '添加服务'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="服务名称" name="server">
        <a-input
          allow-clear
          placeholder="请输入服务名称"
          v-model:value="form.server"
        />
      </a-form-item>
      <a-form-item label="接口地址" name="serverUrl">
        <a-input
          allow-clear
          placeholder="请输入接口地址"
          v-model:value="form.serverUrl"
        />
      </a-form-item>
<!--      <a-form-item label="服务器ID" name="assetsId">-->
<!--        <a-input-->
<!--          allow-clear-->
<!--          placeholder="请输入服务器ID"-->
<!--          v-model:value="form.assetsId"-->
<!--        />-->
<!--      </a-form-item>-->
<!--      <a-form-item label="ip地址" name="ip">-->
<!--        <a-space class="flex justify-between">-->
<!--          <a-input-->
<!--            allow-clear-->
<!--            placeholder="请输入ip地址"-->
<!--            style="width: 240px"-->
<!--            v-model:value="form.ip"-->
<!--          />-->
<!--          <SelectAssets-->
<!--            :placeholder="`所属服务器`"-->
<!--            class="form-item"-->
<!--            v-model:value="form.assetsId"-->
<!--            @done="chooseAssets"-->
<!--          />-->
<!--        </a-space>-->
<!--      </a-form-item>-->
      <a-form-item label="备注" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
      <a-form-item label="排序号" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
<!--      <a-form-item label="状态" name="status">-->
<!--        <a-radio-group v-model:value="form.status">-->
<!--          <a-radio :value="0">显示</a-radio>-->
<!--          <a-radio :value="1">隐藏</a-radio>-->
<!--        </a-radio-group>-->
<!--      </a-form-item>-->
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject } from 'ele-admin-pro';
  import { addOaAssetsServer, updateOaAssetsServer } from '@/api/oa/oaAssetsServer';
  import { OaAssetsServer } from '@/api/oa/oaAssetsServer/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: OaAssetsServer | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<OaAssetsServer>({
    id: undefined,
    server: undefined,
    serverUrl: undefined,
    assetsId: undefined,
    comments: undefined,
    status: undefined,
    userId: undefined,
    userIds: undefined,
    deleted: undefined,
    tenantId: undefined,
    createTime: undefined,
    ip: undefined,
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    server: [
      {
        required: true,
        type: 'string',
        message: '请填写服务名称',
        trigger: 'blur'
      }
    ],
    serverUrl: [
      {
        required: true,
        type: 'string',
        message: '请填写接口地址',
        trigger: 'blur'
      }
    ]
  });

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateOaAssetsServer : addOaAssetsServer;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
